khenaidoo | cfee5f4 | 2018-07-19 22:47:38 -0400 | [diff] [blame] | 1 | # |
| 2 | # Copyright 2016 the original author or authors. |
| 3 | # |
| 4 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 5 | # you may not use this file except in compliance with the License. |
| 6 | # You may obtain a copy of the License at |
| 7 | # |
| 8 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 9 | # |
| 10 | # Unless required by applicable law or agreed to in writing, software |
| 11 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 12 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 13 | # See the License for the specific language governing permissions and |
| 14 | # limitations under the License. |
| 15 | # |
| 16 | |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 17 | # set default shell |
| 18 | SHELL = bash -e -o pipefail |
Kent Hagerman | 074d0e0 | 2019-04-24 17:58:16 -0400 | [diff] [blame] | 19 | |
Zack Williams | 27f59a4 | 2019-05-10 09:12:07 -0700 | [diff] [blame] | 20 | # Variables |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 21 | VERSION ?= $(shell cat ./VERSION) |
Zack Williams | 27f59a4 | 2019-05-10 09:12:07 -0700 | [diff] [blame] | 22 | |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 23 | DOCKER_LABEL_VCS_DIRTY = false |
| 24 | ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0) |
| 25 | DOCKER_LABEL_VCS_DIRTY = true |
| 26 | endif |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 27 | ## Docker related |
David K. Bainbridge | e14914d | 2019-05-24 13:43:05 -0700 | [diff] [blame] | 28 | DOCKER_EXTRA_ARGS ?= |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 29 | DOCKER_REGISTRY ?= |
| 30 | DOCKER_REPOSITORY ?= |
| 31 | DOCKER_TAG ?= ${VERSION}$(shell [[ ${DOCKER_LABEL_VCS_DIRTY} == "true" ]] && echo "-dirty" || true) |
| 32 | RWCORE_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-rw-core |
Andrea Campanella | 7a6cce2 | 2019-12-17 14:10:27 -0800 | [diff] [blame] | 33 | TYPE ?= minimal |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 34 | |
| 35 | ## Docker labels. Only set ref and commit date if committed |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 36 | DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote)) |
| 37 | DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD) |
| 38 | DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ") |
| 39 | DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD) |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 40 | |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 41 | DOCKER_BUILD_ARGS ?= \ |
David K. Bainbridge | e14914d | 2019-05-24 13:43:05 -0700 | [diff] [blame] | 42 | ${DOCKER_EXTRA_ARGS} \ |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 43 | --build-arg org_label_schema_version="${VERSION}" \ |
| 44 | --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \ |
| 45 | --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \ |
| 46 | --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \ |
| 47 | --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \ |
| 48 | --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}" |
| 49 | |
| 50 | DOCKER_BUILD_ARGS_LOCAL ?= ${DOCKER_BUILD_ARGS} \ |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 51 | --build-arg LOCAL_PROTOS=${LOCAL_PROTOS} |
khenaidoo | cfee5f4 | 2018-07-19 22:47:38 -0400 | [diff] [blame] | 52 | |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 53 | # tool containers |
Kent Hagerman | dcd4dcc | 2020-02-25 17:56:17 -0500 | [diff] [blame] | 54 | VOLTHA_TOOLS_VERSION ?= 2.0.0 |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 55 | |
Kent Hagerman | 1b82075 | 2020-02-14 14:45:51 -0500 | [diff] [blame] | 56 | GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 57 | GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report |
| 58 | GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura |
Kent Hagerman | 1b82075 | 2020-02-14 14:45:51 -0500 | [diff] [blame] | 59 | GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint |
| 60 | HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 61 | |
Kent Hagerman | d5e8bd5 | 2020-01-30 16:30:16 -0500 | [diff] [blame] | 62 | .PHONY: rw_core local-protos |
khenaidoo | cfee5f4 | 2018-07-19 22:47:38 -0400 | [diff] [blame] | 63 | |
| 64 | # This should to be the first and default target in this Makefile |
| 65 | help: |
| 66 | @echo "Usage: make [<target>]" |
| 67 | @echo "where available targets are:" |
| 68 | @echo |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 69 | @echo "build : Build the docker images." |
| 70 | @echo " - If this is the first time you are building, choose 'make build' option." |
| 71 | @echo "rw_core : Build the rw_core docker image" |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 72 | @echo "clean : Remove files created by the build and tests" |
Zack Williams | b9b1afb | 2019-12-09 15:28:52 -0700 | [diff] [blame] | 73 | @echo "distclean : Remove sca directory and clean" |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 74 | @echo "docker-push : Push the docker images to an external repository" |
David Bainbridge | 5f3619c | 2019-07-10 22:51:09 +0000 | [diff] [blame] | 75 | @echo "lint-dockerfile : Perform static analysis on Dockerfiles" |
girishk | 5259f8e | 2019-10-10 18:44:44 +0000 | [diff] [blame] | 76 | @echo "lint-mod : Verify the integrity of the 'mod' files" |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 77 | @echo "lint : Shorthand for lint-style & lint-sanity" |
npujar | 03b018e | 2019-11-13 15:29:36 +0530 | [diff] [blame] | 78 | @echo "sca : Runs various SCA through golangci-lint tool" |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 79 | @echo "test : Generate reports for all go tests" |
khenaidoo | cfee5f4 | 2018-07-19 22:47:38 -0400 | [diff] [blame] | 80 | @echo |
| 81 | |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 82 | ## Local Development Helpers |
| 83 | local-protos: |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 84 | ifdef LOCAL_PROTOS |
serkant.uluderya | 2ae470f | 2020-01-21 11:13:09 -0800 | [diff] [blame] | 85 | mkdir -p vendor/github.com/opencord/voltha-protos/v3/go |
| 86 | cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 87 | endif |
| 88 | |
Scott Baker | cb7c88a | 2019-10-16 18:32:48 -0700 | [diff] [blame] | 89 | ## Local Development Helpers |
| 90 | local-lib-go: |
| 91 | ifdef LOCAL_LIB_GO |
serkant.uluderya | 2ae470f | 2020-01-21 11:13:09 -0800 | [diff] [blame] | 92 | mkdir -p vendor/github.com/opencord/voltha-lib-go/v3/pkg |
| 93 | cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v3/pkg/ |
Scott Baker | cb7c88a | 2019-10-16 18:32:48 -0700 | [diff] [blame] | 94 | endif |
| 95 | |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 96 | ## Docker targets |
khenaidoo | cfee5f4 | 2018-07-19 22:47:38 -0400 | [diff] [blame] | 97 | |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 98 | build: docker-build |
khenaidoo | cfee5f4 | 2018-07-19 22:47:38 -0400 | [diff] [blame] | 99 | |
Kent Hagerman | d5e8bd5 | 2020-01-30 16:30:16 -0500 | [diff] [blame] | 100 | docker-build: rw_core |
sslobodr | a3ea7d4 | 2019-01-16 15:03:16 -0500 | [diff] [blame] | 101 | |
Scott Baker | cb7c88a | 2019-10-16 18:32:48 -0700 | [diff] [blame] | 102 | rw_core: local-protos local-lib-go |
Matteo Scandolo | 450933a | 2020-04-30 07:47:08 -0700 | [diff] [blame] | 103 | docker build $(DOCKER_BUILD_ARGS) -t ${RWCORE_IMAGENAME}:${DOCKER_TAG} -f docker/Dockerfile.rw_core . |
| 104 | ifdef BUILD_PROFILED |
| 105 | docker build $(DOCKER_BUILD_ARGS) --build-arg EXTRA_GO_BUILD_TAGS="-tags profile" -t ${RWCORE_IMAGENAME}:${DOCKER_TAG}-profile -f docker/Dockerfile.rw_core . |
| 106 | endif |
David K. Bainbridge | 3768fde | 2020-07-29 21:15:35 -0700 | [diff] [blame] | 107 | ifdef BUILD_RACE |
| 108 | docker build $(DOCKER_BUILD_ARGS) --build-arg GOLANG_IMAGE=golang:1.13.8-buster --build-arg DEPLOY_IMAGE=debian:buster-slim --build-arg EXTRA_GO_BUILD_TAGS="--race" -t ${RWCORE_IMAGENAME}:${DOCKER_TAG}-rd -f docker/Dockerfile.rw_core . |
| 109 | endif |
Don Newton | 8eca462 | 2020-02-10 16:44:48 -0500 | [diff] [blame] | 110 | |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 111 | docker-push: |
Kent Hagerman | f4a3aab | 2019-05-22 14:42:34 -0400 | [diff] [blame] | 112 | docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG} |
Matteo Scandolo | 8ed186a | 2020-05-04 10:52:42 -0700 | [diff] [blame] | 113 | ifdef BUILD_PROFILED |
| 114 | docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG}-profile |
| 115 | endif |
David K. Bainbridge | 3768fde | 2020-07-29 21:15:35 -0700 | [diff] [blame] | 116 | ifdef BUILD_RACE |
| 117 | docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG}-rd |
| 118 | endif |
Andrea Campanella | 7a6cce2 | 2019-12-17 14:10:27 -0800 | [diff] [blame] | 119 | docker-kind-load: |
| 120 | @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi |
| 121 | kind load docker-image ${RWCORE_IMAGENAME}:${DOCKER_TAG} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | rev | cut -c 2- | rev) |
Andrea Campanella | 7a6cce2 | 2019-12-17 14:10:27 -0800 | [diff] [blame] | 122 | |
Matt Jeanneret | 2e3051a | 2019-05-11 15:01:46 -0400 | [diff] [blame] | 123 | ## lint and unit tests |
khenaidoo | d2b6df9 | 2018-12-13 16:37:20 -0500 | [diff] [blame] | 124 | |
David Bainbridge | 5f3619c | 2019-07-10 22:51:09 +0000 | [diff] [blame] | 125 | lint-dockerfile: |
Kent Hagerman | dcd4dcc | 2020-02-25 17:56:17 -0500 | [diff] [blame] | 126 | @echo "Running Dockerfile lint check..." |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 127 | @${HADOLINT} $$(find . -name "Dockerfile.*") |
David Bainbridge | 5f3619c | 2019-07-10 22:51:09 +0000 | [diff] [blame] | 128 | @echo "Dockerfile lint check OK" |
| 129 | |
girishk | 5259f8e | 2019-10-10 18:44:44 +0000 | [diff] [blame] | 130 | lint-mod: |
Kent Hagerman | ca4c51e | 2019-05-02 12:28:55 -0400 | [diff] [blame] | 131 | @echo "Running dependency check..." |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 132 | @${GO} mod verify |
Scott Baker | e4c2a98 | 2019-11-21 16:32:03 -0800 | [diff] [blame] | 133 | @echo "Dependency check OK. Running vendor check..." |
| 134 | @git status > /dev/null |
Kent Hagerman | dcd4dcc | 2020-02-25 17:56:17 -0500 | [diff] [blame] | 135 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1) |
| 136 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1) |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 137 | ${GO} mod tidy |
| 138 | ${GO} mod vendor |
Scott Baker | e4c2a98 | 2019-11-21 16:32:03 -0800 | [diff] [blame] | 139 | @git status > /dev/null |
Kent Hagerman | dcd4dcc | 2020-02-25 17:56:17 -0500 | [diff] [blame] | 140 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1) |
| 141 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1) |
Scott Baker | e4c2a98 | 2019-11-21 16:32:03 -0800 | [diff] [blame] | 142 | @echo "Vendor check OK." |
| 143 | |
Kent Hagerman | 0ab4cb2 | 2019-04-24 13:13:35 -0400 | [diff] [blame] | 144 | |
Kent Hagerman | dcd4dcc | 2020-02-25 17:56:17 -0500 | [diff] [blame] | 145 | lint: lint-mod lint-dockerfile |
Kent Hagerman | 074d0e0 | 2019-04-24 17:58:16 -0400 | [diff] [blame] | 146 | |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 147 | sca: |
| 148 | @rm -rf ./sca-report |
Scott Baker | 18ea5a4 | 2019-10-15 16:08:42 -0700 | [diff] [blame] | 149 | @mkdir -p ./sca-report |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 150 | @echo "Running static code analysis..." |
Kent Hagerman | d9cc2e9 | 2019-11-04 13:28:15 -0500 | [diff] [blame] | 151 | @${GOLANGCI_LINT} run --deadline=6m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml |
Kent Hagerman | 1b82075 | 2020-02-14 14:45:51 -0500 | [diff] [blame] | 152 | @echo "" |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 153 | @echo "Static code analysis OK" |
Scott Baker | 18ea5a4 | 2019-10-15 16:08:42 -0700 | [diff] [blame] | 154 | |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 155 | test: local-lib-go |
Kent Hagerman | ca4c51e | 2019-05-02 12:28:55 -0400 | [diff] [blame] | 156 | @mkdir -p ./tests/results |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 157 | @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\ |
Zack Williams | 7cf7800 | 2019-04-30 21:45:35 -0700 | [diff] [blame] | 158 | RETURN=$$? ;\ |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 159 | ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\ |
| 160 | ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\ |
Zack Williams | 7cf7800 | 2019-04-30 21:45:35 -0700 | [diff] [blame] | 161 | exit $$RETURN |
Kent Hagerman | 074d0e0 | 2019-04-24 17:58:16 -0400 | [diff] [blame] | 162 | |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 163 | clean: distclean |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 164 | |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 165 | distclean: |
| 166 | rm -rf ./sca-report |
David K. Bainbridge | 1678e19 | 2019-05-17 11:48:29 -0700 | [diff] [blame] | 167 | |
Scott Baker | cb7c88a | 2019-10-16 18:32:48 -0700 | [diff] [blame] | 168 | mod-update: |
Kent Hagerman | 812b257 | 2020-01-28 11:57:51 -0500 | [diff] [blame] | 169 | ${GO} mod tidy |
| 170 | ${GO} mod vendor |